From f87a946b909f8959fb0d3b32dd522e036e2165b3 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Mon, 28 Nov 2011 10:12:25 -0600
Subject: Helper function for determining if item within cat is ec

---
 lib/grade/grade_category.php |   31 ++++++++++++++++---------------
 1 files changed, 16 insertions(+), 15 deletions(-)

diff --git a/lib/grade/grade_category.php b/lib/grade/grade_category.php
index f2e2048..a63f8e9 100644
--- a/lib/grade/grade_category.php
+++ b/lib/grade/grade_category.php
@@ -888,23 +888,16 @@ class grade_category extends grade_object {
      * @return array Limited grades.
      */
     public function apply_limit_rules(&$grade_values, $items) {
-        $extraused = $this->is_extracredit_used();
 
         if (!empty($this->droplow)) {
             asort($grade_values, SORT_NUMERIC);
             $dropped = 0;
 
             foreach ($grade_values as $itemid=>$value) {
-                $coef = $items[$itemid]->aggregationcoef;
-
-                $validextra = (
-                    ($this->aggregation == GRADE_AGGREGATE_WEIGHTED_MEAN and $coef < 0) or
-                    $coef > 0
-                );
 
                 if ($dropped < $this->droplow) {
 
-                    if ($extraused and $validextra) {
+                    if ($this->is_item_extra_credit($items[$itemid])) {
                         // no drop low for extra credits
 
                     } else {
@@ -923,14 +916,8 @@ class grade_category extends grade_object {
             $kept = 0;
 
             foreach ($grade_values as $itemid=>$value) {
-                $coef = $items[$itemid]->aggregationcoef;
-
-                $validextra = (
-                    ($this->aggregation == GRADE_AGGREGATE_WEIGHTED_MEAN and $coef < 0) or
-                    $coef > 0
-                );
 
-                if ($extraused and $validextra) {
+                if ($this->is_item_extra_credit($items[$itemid])) {
                     // we keep all extra credits
 
                 } else if ($kept < $this->keephigh) {
@@ -943,6 +930,20 @@ class grade_category extends grade_object {
         }
     }
 
+    function is_item_extra_credit($item) {
+        $extraused = $this->is_extracredit_used();
+
+        if (!$extraused)
+            return false;
+
+        $validextra = (
+            ($this->aggregation != GRADE_AGGREGATE_WEIGHTED_MEAN && $coef > 0) ||
+            $coef < 0
+        );
+
+        return ($extraused && $validextra);
+    }
+
     /**
      * Returns true if category uses extra credit of any kind
      *
-- 
1.7.1


